Commit 17136906 authored by unknown's avatar unknown

Clean up the mysql_install_db script to ensure that a sane environment is

available and reduce the chance of failure.  This should fix bug#28585
which is caused by the script being quite random in how it finds files it
requires and not giving very good feedback to the user about what went
wrong.

Also update make_binary_distribution so that it provides the correct path
to the required SQL scripts when generating mysql_install_db.  The script
only previously worked because of the permissive behaviour which looked
around the current working directory before the "correct" location.  This
could lead to severe problems if the user happened to run the script from
a location which contained older or even broken copies of the SQL scripts.

We now require either a complete binary release (and the mysql_install_db
script ran from inside the extracted archive), or an installed compiled
tree, as this is the only way we can be sure everything that we need is
available and ready to run.

While working on this fix, also clean up the mysql_install_db script a lot
to make it simpler, easier to read, and hopefully less prone to bugs in
the future.


scripts/make_binary_distribution.sh:
  SQL files live in ./share not ./support-files in binary distribution.
scripts/mysql_install_db.sh:
  Use a consistent shell indentation style.
parent 47507276
...@@ -318,7 +318,7 @@ if [ $BASE_SYSTEM != "netware" ] ; then ...@@ -318,7 +318,7 @@ if [ $BASE_SYSTEM != "netware" ] ; then
copyfileto $BASE/bin scripts/* copyfileto $BASE/bin scripts/*
$BASE/bin/replace \@localstatedir\@ ./data \@bindir\@ ./bin \@scriptdir\@ \ $BASE/bin/replace \@localstatedir\@ ./data \@bindir\@ ./bin \@scriptdir\@ \
./bin \@libexecdir\@ ./bin \@sbindir\@ ./bin \@prefix\@ . \@HOSTNAME\@ \ ./bin \@libexecdir\@ ./bin \@sbindir\@ ./bin \@prefix\@ . \@HOSTNAME\@ \
@HOSTNAME@ \@pkgdatadir\@ ./support-files \ @HOSTNAME@ \@pkgdatadir\@ ./share \
< scripts/mysql_install_db.sh > $BASE/scripts/mysql_install_db < scripts/mysql_install_db.sh > $BASE/scripts/mysql_install_db
$BASE/bin/replace \@prefix\@ /usr/local/mysql \@bindir\@ ./bin \ $BASE/bin/replace \@prefix\@ /usr/local/mysql \@bindir\@ ./bin \
\@sbindir\@ ./bin \@libexecdir\@ ./bin \ \@sbindir\@ ./bin \@libexecdir\@ ./bin \
......
...@@ -18,26 +18,65 @@ ...@@ -18,26 +18,65 @@
# #
# All unrecognized arguments to this script are passed to mysqld. # All unrecognized arguments to this script are passed to mysqld.
force=0
in_rpm=0 in_rpm=0
ip_only=0
windows=0 windows=0
defaults=""
user=""
case "$1" in case "$1" in
--no-defaults|--defaults-file=*|--defaults-extra-file=*) --no-defaults|--defaults-file=*|--defaults-extra-file=*)
defaults="$1"; shift defaults="$1"; shift
;; ;;
esac esac
usage()
{
cat <<EOF
Usage: $0 [OPTIONS]
--basedir=path The path to the MySQL installation directory.
--datadir=path The path to the MySQL data directory.
--force Causes mysql_install_db to run even if DNS does not
work. In that case, grant table entries that normally
use hostnames will use IP addresses.
--ldata=path The path to the MySQL data directory.
--rpm For internal use. This option is used by RPM files
during the MySQL installation process.
--skip-name-resolve Use IP addresses rather than hostnames when creating
grant table entries. This option can be useful if
your DNS does not work.
--srcdir=path For internal use. The directory under which
mysql_install_db looks for support files such as the
error message file and the file for popoulating the
help tables.
--user=user_name The login username to use for running mysqld. Files
and directories created by mysqld will be owned by this
user. You must be root to use this option. By default
mysqld runs using your current login name and files and
directories that it creates will be owned by you.
--windows For internal use. This option is used for creating
Windows distributions.
All other options are passed to the mysqld program
EOF
exit 1
}
s_echo() s_echo()
{ {
if test "$in_rpm" -eq 0 -a "$windows" -eq 0 if test "$in_rpm" -eq 0 -a "$windows" -eq 0
then then
echo $1 echo "$1"
fi fi
} }
parse_arguments() { parse_arg()
{
echo "$1" | sed -e 's/^[^=]*=//'
}
parse_arguments()
{
# We only need to pass arguments through to the server if we don't # We only need to pass arguments through to the server if we don't
# handle them here. So, we collect unrecognized options (passed on # handle them here. So, we collect unrecognized options (passed on
# the command line) into the args variable. # the command line) into the args variable.
...@@ -51,17 +90,18 @@ parse_arguments() { ...@@ -51,17 +90,18 @@ parse_arguments() {
for arg do for arg do
case "$arg" in case "$arg" in
--force) force=1 ;; --force) force=1 ;;
--basedir=*) basedir=`echo "$arg" | sed -e 's/^[^=]*=//'` ;; --basedir=*) basedir=`parse_arg "$arg"` ;;
--srcdir=*) srcdir=`echo "$arg" | sed -e 's/^[^=]*=//'` ;; --srcdir=*) srcdir=`parse_arg "$arg"` ;;
--ldata=*|--datadir=*) ldata=`echo "$arg" | sed -e 's/^[^=]*=//'` ;; --ldata=*|--datadir=*) ldata=`parse_arg "$arg"` ;;
--user=*) --user=*)
# Note that the user will be passed to mysqld so that it runs # Note that the user will be passed to mysqld so that it runs
# as 'user' (crucial e.g. if log-bin=/some_other_path/ # as 'user' (crucial e.g. if log-bin=/some_other_path/
# where a chown of datadir won't help) # where a chown of datadir won't help)
user=`echo "$arg" | sed -e 's/^[^=]*=//'` ;; user=`parse_arg "$arg"` ;;
--skip-name-resolve) ip_only=1 ;; --skip-name-resolve) ip_only=1 ;;
--verbose) verbose=1 ;; # Obsolete --verbose) verbose=1 ;; # Obsolete
--rpm) in_rpm=1 ;; --rpm) in_rpm=1 ;;
--help) usage ;;
--windows) --windows)
# This is actually a "cross bootstrap" argument used when # This is actually a "cross bootstrap" argument used when
...@@ -89,137 +129,100 @@ parse_arguments() { ...@@ -89,137 +129,100 @@ parse_arguments() {
done done
} }
# Get first arguments from the my.cfg file, groups [mysqld] and # Sanity check - make sure we can find my_print_defaults either in the binary
# [mysql_install_db], and then merge with the command line arguments # distribution or within the installed source compile.
if test -x ./bin/my_print_defaults print_defaults="@bindir@/my_print_defaults"
then if ! test -x $print_defaults
print_defaults="./bin/my_print_defaults"
elif test -x ./extra/my_print_defaults
then then
print_defaults="./extra/my_print_defaults" echo "FATAL ERROR: Could not find $print_defaults"
elif test -x @bindir@/my_print_defaults echo
then echo "If you are using a binary release, you must run this script from"
print_defaults="@bindir@/my_print_defaults" echo "within the directory the archive extracted into. If you compiled"
elif test -x @bindir@/mysql_print_defaults echo "MySQL yourself you must run 'make install' first."
then exit 1
print_defaults="@bindir@/mysql_print_defaults"
else
print_defaults="my_print_defaults"
fi fi
args= # Firstly, get arguments from the groups [mysqld] and [mysql_install_db]
ldata= # in the my.cfg file, then re-run to merge with command line arguments.
execdir=
bindir=
basedir=
srcdir=
force=0
parse_arguments `$print_defaults $defaults mysqld mysql_install_db` parse_arguments `$print_defaults $defaults mysqld mysql_install_db`
parse_arguments PICK-ARGS-FROM-ARGV "$@" parse_arguments PICK-ARGS-FROM-ARGV "$@"
test -z "$ldata" && ldata=@localstatedir@ # Path to MySQL installation directory
if test -z "$basedir" if test -z "$basedir"
then then
basedir=@prefix@ basedir="@prefix@"
bindir=@bindir@ bindir="@bindir@"
execdir=@libexecdir@ mysqld="@libexecdir@/mysqld"
pkgdatadir=@pkgdatadir@
else else
bindir="$basedir/bin" bindir="$basedir/bin"
if test -x "$basedir/libexec/mysqld" for dir in libexec sbin bin
then
execdir="$basedir/libexec"
elif test -x "$basedir/sbin/mysqld"
then
execdir="$basedir/sbin"
else
execdir="$basedir/bin"
fi
fi
# Find SQL scripts needed for bootstrap
fill_help_tables="fill_help_tables.sql"
create_system_tables="mysql_system_tables.sql"
fill_system_tables="mysql_system_tables_data.sql"
if test -n "$srcdir"
then
fill_help_tables=$srcdir/scripts/$fill_help_tables
create_system_tables=$srcdir/scripts/$create_system_tables
fill_system_tables=$srcdir/scripts/$fill_system_tables
else
for i in $basedir/support-files $basedir/share $basedir/share/mysql \
$basedir/scripts `pwd` `pwd`/scripts @pkgdatadir@
do do
if test -f $i/$fill_help_tables if test -x "$basedir/$dir/mysqld"
then then
pkgdatadir=$i mysqld="$basedir/$dir/mysqld"
break break
fi fi
done done
if test -z "$mysqld"
fill_help_tables=$pkgdatadir/$fill_help_tables then
create_system_tables=$pkgdatadir/$create_system_tables echo "FATAL ERROR: Could not find mysqld inside supplied --basedir"
fill_system_tables=$pkgdatadir/$fill_system_tables exit 1
fi
fi fi
if test ! -f $create_system_tables # Path to data directory
if test -z "$ldata"
then then
echo "FATAL ERROR: Could not find SQL file '$create_system_tables' in" ldata="@localstatedir@"
echo "@pkgdatadir@ or inside $basedir"
exit 1;
fi fi
if test ! -f $fill_help_tables # Set up paths to SQL scripts required for bootstrap and ensure they exist.
if test -n "$srcdir"
then then
echo "FATAL ERROR: Could not find help file '$fill_help_tables' in" pkgdatadir="$srcdir/scripts"
echo "@pkgdatadir@ or inside $basedir" else
exit 1; pkgdatadir="@pkgdatadir@"
fi fi
if test ! -f $fill_system_tables fill_help_tables="$pkgdatadir/fill_help_tables.sql"
then create_system_tables="$pkgdatadir/mysql_system_tables.sql"
echo "FATAL ERROR: Could not find help file '$fill_system_tables' in" fill_system_tables="$pkgdatadir/mysql_system_tables_data.sql"
echo "@pkgdatadir@ or inside $basedir"
exit 1;
fi
# Find executables and paths for f in $fill_help_tables $create_system_tables $fill_system_tables
mysqld=$execdir/mysqld do
mysqld_opt="" if test ! -f "$f"
scriptdir=$bindir then
echo "FATAL ERROR: Could not find SQL file '$f'"
exit 1
fi
done
if test "$windows" = 1 # Set up Windows-specific paths
if test "$windows" -eq 1
then then
mysqld="./sql/mysqld" mysqld="./sql/mysqld"
if test -n "$srcdir" -a -f $srcdir/sql/share/english/errmsg.sys if test -n "$srcdir" -a -f "$srcdir/sql/share/english/errmsg.sys"
then then
langdir=$srcdir/sql/share/english langdir="$srcdir/sql/share/english"
else else
langdir=./sql/share/english langdir="./sql/share/english"
fi fi
mysqld_opt="--language=$langdir" mysqld_opt="--language=$langdir"
scriptdir="./scripts"
fi fi
if test ! -x $mysqld # Make sure mysqld is available in default location (--basedir option is
# already tested above).
if test ! -x "$mysqld"
then then
if test "$in_rpm" = 1 echo "FATAL ERROR: $mysqld not found!"
then exit 1
echo "FATAL ERROR $mysqld not found!"
exit 1
else
echo "FATAL ERROR Didn't find $mysqld"
echo "You should do a 'make install' before executing this script"
exit 1
fi
fi fi
# Try to determine the hostname # Try to determine the hostname
hostname=`@HOSTNAME@` hostname=`@HOSTNAME@`
# Check if hostname is valid # Check if hostname is valid
if test "$windows" = 0 -a "$in_rpm" = 0 -a $force = 0 if test "$windows" -eq 0 -a "$in_rpm" -eq 0 -a "$force" -eq 0
then then
resolved=`$bindir/resolveip $hostname 2>&1` resolved=`$bindir/resolveip $hostname 2>&1`
if [ $? -ne 0 ] if [ $? -ne 0 ]
...@@ -244,39 +247,35 @@ then ...@@ -244,39 +247,35 @@ then
fi fi
fi fi
if test "$ip_only" = "1" if test "$ip_only" -eq 1
then then
ip=`echo "$resolved" | awk '/ /{print $6}'` hostname=`echo "$resolved" | awk '/ /{print $6}'`
hostname=$ip
fi fi
# Create database directories mysql & test # Create database directories mysql & test
if test ! -d $ldata; then for dir in $ldata $ldata/mysql $ldata/test
mkdir $ldata; do
chmod 700 $ldata ; if test ! -d $dir
fi then
if test ! -d $ldata/mysql; then mkdir -p $dir
mkdir $ldata/mysql; chmod 700 $dir
chmod 700 $ldata/mysql ; fi
fi if test -w / -a ! -z "$user"
if test ! -d $ldata/test; then then
mkdir $ldata/test; chown $user $dir
chmod 700 $ldata/test ; fi
fi done
if test -w / -a ! -z "$user"; then
chown $user $ldata $ldata/mysql $ldata/test;
fi
if test -n "$user"; then if test -n "$user"
then
args="$args --user=$user" args="$args --user=$user"
fi fi
# Peform the install of system tables # Peform the install of system tables
mysqld_bootstrap="${MYSQLD_BOOTSTRAP-$mysqld}" mysqld_bootstrap="${MYSQLD_BOOTSTRAP-$mysqld}"
mysqld_install_cmd_line="$mysqld_bootstrap $defaults $mysqld_opt --bootstrap \ mysqld_install_cmd_line="$mysqld_bootstrap $defaults $mysqld_opt --bootstrap \
--basedir=$basedir --datadir=$ldata --skip-innodb \ --basedir=$basedir --datadir=$ldata --skip-innodb --skip-bdb \
--skip-bdb --skip-ndbcluster $args --max_allowed_packet=8M \ --skip-ndbcluster $args --max_allowed_packet=8M --net_buffer_length=16K"
--net_buffer_length=16K"
# Pipe mysql_system_tables.sql to "mysqld --bootstrap" # Pipe mysql_system_tables.sql to "mysqld --bootstrap"
s_echo "Installing MySQL system tables..." s_echo "Installing MySQL system tables..."
...@@ -284,23 +283,20 @@ if `(echo "use mysql;"; cat $create_system_tables $fill_system_tables) | $mysqld ...@@ -284,23 +283,20 @@ if `(echo "use mysql;"; cat $create_system_tables $fill_system_tables) | $mysqld
then then
s_echo "OK" s_echo "OK"
if test -n "$fill_help_tables" s_echo "Filling help tables..."
# Pipe fill_help_tables.sql to "mysqld --bootstrap"
if `(echo "use mysql;"; cat $fill_help_tables) | $mysqld_install_cmd_line`
then then
s_echo "Filling help tables..." # Fill suceeded
# Pipe fill_help_tables.sql to "mysqld --bootstrap" s_echo "OK"
if `(echo "use mysql;"; cat $fill_help_tables) | $mysqld_install_cmd_line` else
then echo
# Fill suceeded echo "WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!"
s_echo "OK" echo "The \"HELP\" command might not work properly"
else echo
echo ""
echo "WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!"
echo "The \"HELP\" command might not work properly"
echo ""
fi
fi fi
s_echo "" s_echo
s_echo "To start mysqld at boot time you have to copy" s_echo "To start mysqld at boot time you have to copy"
s_echo "support-files/mysql.server to the right place for your system" s_echo "support-files/mysql.server to the right place for your system"
s_echo s_echo
...@@ -319,7 +315,7 @@ then ...@@ -319,7 +315,7 @@ then
echo "$bindir/mysqladmin -u root -h $hostname password 'new-password'" echo "$bindir/mysqladmin -u root -h $hostname password 'new-password'"
echo "See the manual for more instructions." echo "See the manual for more instructions."
if test "$in_rpm" = "0" if test "$in_rpm" -eq 0
then then
echo "You can start the MySQL daemon with:" echo "You can start the MySQL daemon with:"
echo "cd @prefix@ ; $bindir/mysqld_safe &" echo "cd @prefix@ ; $bindir/mysqld_safe &"
......
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment